Index: branches/2936_GQAPIntegration/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Algorithms/3.3/GRASP/GRASP.cs
===================================================================
--- branches/2936_GQAPIntegration/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Algorithms/3.3/GRASP/GRASP.cs	(revision 16077)
+++ branches/2936_GQAPIntegration/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Algorithms/3.3/GRASP/GRASP.cs	(revision 16712)
@@ -30,4 +30,5 @@
 using HeuristicLab.Parameters;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HEAL.Attic;
 
 namespace HeuristicLab.Problems.GeneralizedQuadraticAssignment.Algorithms {
@@ -41,5 +42,5 @@
   [Item("GRASP+PR (GQAP)", "The algorithm implements the Greedy Randomized Adaptive Search Procedure (GRASP) with Path Relinking as described in Mateus, G., Resende, M., and Silva, R. 2011. GRASP with path-relinking for the generalized quadratic assignment problem. Journal of Heuristics 17, Springer Netherlands, pp. 527-565.")]
   [Creatable(CreatableAttribute.Categories.PopulationBasedAlgorithms)]
-  [StorableClass]
+  [StorableType("1FF6B7FC-58CA-4F89-BCAF-31CFC0B0546C")]
   public sealed class GRASP : StochasticAlgorithm<GRASPContext, IntegerVectorEncoding> {
 
@@ -123,5 +124,5 @@
 
     [StorableConstructor]
-    private GRASP(bool deserializing) : base(deserializing) { }
+    private GRASP(StorableConstructorFlag _) : base(_) { }
     private GRASP(GRASP original, Cloner cloner)
       : base(original, cloner) {
Index: branches/2936_GQAPIntegration/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Algorithms/3.3/GRASP/GRASPContext.cs
===================================================================
--- branches/2936_GQAPIntegration/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Algorithms/3.3/GRASP/GRASPContext.cs	(revision 16077)
+++ branches/2936_GQAPIntegration/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Algorithms/3.3/GRASP/GRASPContext.cs	(revision 16712)
@@ -25,8 +25,9 @@
 using HeuristicLab.Parameters;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HEAL.Attic;
 
 namespace HeuristicLab.Problems.GeneralizedQuadraticAssignment.Algorithms {
   [Item("GRASP+PR (GQAP) Context", "Context for GRASP+PR (GQAP).")]
-  [StorableClass]
+  [StorableType("40C0A979-FFDB-43E0-89A0-6553BD3EB9DB")]
   public sealed class GRASPContext : PopulationContext<ISingleObjectiveSolutionScope<GQAPSolution>> {
     
@@ -50,5 +51,5 @@
     
     [StorableConstructor]
-    private GRASPContext(bool deserializing) : base(deserializing) { }
+    private GRASPContext(StorableConstructorFlag _) : base(_) { }
     private GRASPContext(GRASPContext original, Cloner cloner)
       : base(original, cloner) {
Index: branches/2936_GQAPIntegration/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Algorithms/3.3/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Algorithms-3.3.csproj
===================================================================
--- branches/2936_GQAPIntegration/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Algorithms/3.3/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Algorithms-3.3.csproj	(revision 16077)
+++ branches/2936_GQAPIntegration/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Algorithms/3.3/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Algorithms-3.3.csproj	(revision 16712)
@@ -10,5 +10,5 @@
     <RootNamespace>HeuristicLab.Problems.GeneralizedQuadraticAssignment.Algorithms</RootNamespace>
     <AssemblyName>HeuristicLab.Problems.GeneralizedQuadraticAssignment.Algorithms-3.3</AssemblyName>
-    <TargetFrameworkVersion>v4.5</TargetFrameworkVersion>
+    <TargetFrameworkVersion>v4.6.1</TargetFrameworkVersion>
     <FileAlignment>512</FileAlignment>
     <TargetFrameworkProfile />
@@ -42,4 +42,9 @@
   </PropertyGroup>
   <ItemGroup>
+    <Reference Include="HEAL.Attic, Version=1.0.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
+      <SpecificVersion>False</SpecificVersion>
+      <HintPath>..\..\..\..\trunk\bin\HEAL.Attic.dll</HintPath>
+      <Private>False</Private>
+    </Reference>
     <Reference Include="HeuristicLab.Analysis-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
       <SpecificVersion>False</SpecificVersion>
Index: branches/2936_GQAPIntegration/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Algorithms/3.3/Infrastructure/Algorithms/ContextAlgorithm.cs
===================================================================
--- branches/2936_GQAPIntegration/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Algorithms/3.3/Infrastructure/Algorithms/ContextAlgorithm.cs	(revision 16077)
+++ branches/2936_GQAPIntegration/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Algorithms/3.3/Infrastructure/Algorithms/ContextAlgorithm.cs	(revision 16712)
@@ -31,8 +31,9 @@
 using HeuristicLab.Parameters;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HEAL.Attic;
 
 namespace HeuristicLab.Problems.GeneralizedQuadraticAssignment.Algorithms {
   [Item("Context-based Algorithm", "Algorithms that make use of contexts to facilitate applying operators.")]
-  [StorableClass]
+  [StorableType("F4D85B12-B512-4CC5-B220-69C01E2C8DBB")]
   public abstract class ContextAlgorithm<TContext, TEncoding> : BasicAlgorithm
     where TContext : class, IContext, new()
@@ -110,5 +111,5 @@
 
     [StorableConstructor]
-    protected ContextAlgorithm(bool deserializing) : base(deserializing) { }
+    protected ContextAlgorithm(StorableConstructorFlag _) : base(_) { }
     protected ContextAlgorithm(ContextAlgorithm<TContext, TEncoding> original, Cloner cloner)
       : base(original, cloner) {
Index: branches/2936_GQAPIntegration/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Algorithms/3.3/Infrastructure/Algorithms/StochasticAlgorithm.cs
===================================================================
--- branches/2936_GQAPIntegration/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Algorithms/3.3/Infrastructure/Algorithms/StochasticAlgorithm.cs	(revision 16077)
+++ branches/2936_GQAPIntegration/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Algorithms/3.3/Infrastructure/Algorithms/StochasticAlgorithm.cs	(revision 16712)
@@ -28,8 +28,9 @@
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 using HeuristicLab.Random;
+using HEAL.Attic;
 
 namespace HeuristicLab.Problems.GeneralizedQuadraticAssignment.Algorithms {
   [Item("Stochastic Algorithm", "Stochastic context-based algorithms to facilitate applying operators.")]
-  [StorableClass]
+  [StorableType("75B72520-ECBC-42F7-8560-448940825847")]
   public abstract class StochasticAlgorithm<TContext, TEncoding> : ContextAlgorithm<TContext, TEncoding>
     where TContext : class, IStochasticContext, new()
@@ -57,5 +58,5 @@
 
     [StorableConstructor]
-    protected StochasticAlgorithm(bool deserializing) : base(deserializing) { }
+    protected StochasticAlgorithm(StorableConstructorFlag _) : base(_) { }
     protected StochasticAlgorithm(StochasticAlgorithm<TContext, TEncoding> original, Cloner cloner)
       : base(original, cloner) {
Index: branches/2936_GQAPIntegration/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Algorithms/3.3/Infrastructure/Contexts/BasicContext.cs
===================================================================
--- branches/2936_GQAPIntegration/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Algorithms/3.3/Infrastructure/Contexts/BasicContext.cs	(revision 16077)
+++ branches/2936_GQAPIntegration/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Algorithms/3.3/Infrastructure/Contexts/BasicContext.cs	(revision 16712)
@@ -28,8 +28,9 @@
 using HeuristicLab.Parameters;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HEAL.Attic;
 
 namespace HeuristicLab.Problems.GeneralizedQuadraticAssignment.Algorithms {
   [Item("Basic Context", "A base class for algorithms' contexts.")]
-  [StorableClass]
+  [StorableType("32A031BB-19B1-4792-B3C0-673FF52A75E1")]
   public class BasicContext : ParameterizedNamedItem, IContext {
 
@@ -77,5 +78,5 @@
 
     [StorableConstructor]
-    protected BasicContext(bool deserializing) : base(deserializing) { }
+    protected BasicContext(StorableConstructorFlag _) : base(_) { }
     protected BasicContext(BasicContext original, Cloner cloner)
     : base(original, cloner) {
Index: branches/2936_GQAPIntegration/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Algorithms/3.3/Infrastructure/Contexts/PopulationContext.cs
===================================================================
--- branches/2936_GQAPIntegration/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Algorithms/3.3/Infrastructure/Contexts/PopulationContext.cs	(revision 16077)
+++ branches/2936_GQAPIntegration/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Algorithms/3.3/Infrastructure/Contexts/PopulationContext.cs	(revision 16712)
@@ -25,8 +25,9 @@
 using HeuristicLab.Core;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HEAL.Attic;
 
 namespace HeuristicLab.Problems.GeneralizedQuadraticAssignment.Algorithms {
   [Item("Population Context", "A context for population-based algorithms.")]
-  [StorableClass]
+  [StorableType("328AF409-9ECE-4E59-A842-ABBD98CBE386")]
   public abstract class PopulationContext<TSolutionScope> : StochasticContext
     where TSolutionScope: class, IScope {
@@ -56,5 +57,5 @@
 
     [StorableConstructor]
-    protected PopulationContext(bool deserializing) : base(deserializing) { }
+    protected PopulationContext(StorableConstructorFlag _) : base(_) { }
     protected PopulationContext(PopulationContext<TSolutionScope> original, Cloner cloner)
       : base(original, cloner) {
Index: branches/2936_GQAPIntegration/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Algorithms/3.3/Infrastructure/Contexts/SingleSolutionContext.cs
===================================================================
--- branches/2936_GQAPIntegration/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Algorithms/3.3/Infrastructure/Contexts/SingleSolutionContext.cs	(revision 16077)
+++ branches/2936_GQAPIntegration/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Algorithms/3.3/Infrastructure/Contexts/SingleSolutionContext.cs	(revision 16712)
@@ -23,8 +23,9 @@
 using HeuristicLab.Core;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HEAL.Attic;
 
 namespace HeuristicLab.Problems.GeneralizedQuadraticAssignment.Algorithms {
   [Item("Single Solution Context", "A context for single solution algorithms.")]
-  [StorableClass]
+  [StorableType("C894BD11-05CE-44E2-B25D-606071B78757")]
   public abstract class SingleSolutionContext<TSolutionScope> : StochasticContext
     where TSolutionScope: class, IScope {
@@ -44,5 +45,5 @@
 
     [StorableConstructor]
-    protected SingleSolutionContext(bool deserializing) : base(deserializing) { }
+    protected SingleSolutionContext(StorableConstructorFlag _) : base(_) { }
     protected SingleSolutionContext(SingleSolutionContext<TSolutionScope> original, Cloner cloner)
       : base(original, cloner) {
Index: branches/2936_GQAPIntegration/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Algorithms/3.3/Infrastructure/Contexts/StochasticContext.cs
===================================================================
--- branches/2936_GQAPIntegration/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Algorithms/3.3/Infrastructure/Contexts/StochasticContext.cs	(revision 16077)
+++ branches/2936_GQAPIntegration/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Algorithms/3.3/Infrastructure/Contexts/StochasticContext.cs	(revision 16712)
@@ -24,8 +24,9 @@
 using HeuristicLab.Parameters;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HEAL.Attic;
 
 namespace HeuristicLab.Problems.GeneralizedQuadraticAssignment.Algorithms {
   [Item("Stochastic Context", "A base class for stochastic algorithms' contexts.")]
-  [StorableClass]
+  [StorableType("AF5AA1FB-F4C2-450C-A760-C7B1EDBAFCB7")]
   public class StochasticContext : BasicContext, IStochasticContext {
     
@@ -38,5 +39,5 @@
 
     [StorableConstructor]
-    protected StochasticContext(bool deserializing) : base(deserializing) { }
+    protected StochasticContext(StorableConstructorFlag _) : base(_) { }
     protected StochasticContext(StochasticContext original, Cloner cloner)
     : base(original, cloner) {
Index: branches/2936_GQAPIntegration/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Algorithms/3.3/Infrastructure/Interfaces.cs
===================================================================
--- branches/2936_GQAPIntegration/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Algorithms/3.3/Infrastructure/Interfaces.cs	(revision 16077)
+++ branches/2936_GQAPIntegration/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Algorithms/3.3/Infrastructure/Interfaces.cs	(revision 16712)
@@ -22,6 +22,8 @@
 using System;
 using HeuristicLab.Core;
+using HEAL.Attic;
 
 namespace HeuristicLab.Problems.GeneralizedQuadraticAssignment.Algorithms {
+  [StorableType("8AE6AC8A-7F9A-44C7-911A-4E618D1CC928")]
   public interface ISingleObjectiveSolutionScope<TSolution> : IScope {
     TSolution Solution { get; set; }
@@ -29,4 +31,5 @@
   }
 
+  [StorableType("F007BD11-9CF1-418E-A113-BA68EFD0BC73")]
   public interface IContext : IExecutionContext {
     new IExecutionContext Parent { get; set; }
@@ -38,4 +41,5 @@
   }
 
+  [StorableType("5723FC2A-39F7-4C7D-88D8-944C347B52D8")]
   public interface IStochasticContext : IContext {
     IRandom Random { get; set; }
Index: branches/2936_GQAPIntegration/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Algorithms/3.3/Infrastructure/SingleObjectiveSolutionScope.cs
===================================================================
--- branches/2936_GQAPIntegration/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Algorithms/3.3/Infrastructure/SingleObjectiveSolutionScope.cs	(revision 16077)
+++ branches/2936_GQAPIntegration/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Algorithms/3.3/Infrastructure/SingleObjectiveSolutionScope.cs	(revision 16712)
@@ -25,9 +25,9 @@
 using HeuristicLab.Core;
 using HeuristicLab.Data;
-using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HEAL.Attic;
 
 namespace HeuristicLab.Problems.GeneralizedQuadraticAssignment.Algorithms {
   [Item("Solution Scope", "Scope for an individual/solution of a single-objective single-encoded problem.")]
-  [StorableClass]
+  [StorableType("C9026A26-C121-4F2E-88F8-2AA1ABF4D142")]
   public sealed class SingleObjectiveSolutionScope<T> : NamedItem, ISingleObjectiveSolutionScope<T> where T : class, IItem {
     public new static Image StaticItemImage {
@@ -73,5 +73,5 @@
 
     [StorableConstructor]
-    private SingleObjectiveSolutionScope(bool deserializing) : base(deserializing) { }
+    private SingleObjectiveSolutionScope(StorableConstructorFlag _) : base(_) { }
     private SingleObjectiveSolutionScope(SingleObjectiveSolutionScope<T> original, Cloner cloner)
       : base(original, cloner) {
Index: branches/2936_GQAPIntegration/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Algorithms/3.3/Plugin.cs
===================================================================
--- branches/2936_GQAPIntegration/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Algorithms/3.3/Plugin.cs	(revision 16077)
+++ branches/2936_GQAPIntegration/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Algorithms/3.3/Plugin.cs	(revision 16712)
@@ -23,6 +23,7 @@
 
 namespace HeuristicLab.Problems.GeneralizedQuadraticAssignment.Algorithms {
-  [Plugin("HeuristicLab.Problems.GeneralizedQuadraticAssignment.Algorithms", "3.3.15.15890")]
+  [Plugin("HeuristicLab.Problems.GeneralizedQuadraticAssignment.Algorithms", "3.3.15.16077")]
   [PluginFile("HeuristicLab.Problems.GeneralizedQuadraticAssignment.Algorithms-3.3.dll", PluginFileType.Assembly)]
+  [PluginDependency("HeuristicLab.Attic", "1.0")]
   [PluginDependency("HeuristicLab.Analysis", "3.3")]
   [PluginDependency("HeuristicLab.Collections", "3.3")]
Index: branches/2936_GQAPIntegration/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Algorithms/3.3/Plugin.cs.frame
===================================================================
--- branches/2936_GQAPIntegration/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Algorithms/3.3/Plugin.cs.frame	(revision 16077)
+++ branches/2936_GQAPIntegration/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Algorithms/3.3/Plugin.cs.frame	(revision 16712)
@@ -25,4 +25,5 @@
   [Plugin("HeuristicLab.Problems.GeneralizedQuadraticAssignment.Algorithms", "3.3.15.$WCREV$")]
   [PluginFile("HeuristicLab.Problems.GeneralizedQuadraticAssignment.Algorithms-3.3.dll", PluginFileType.Assembly)]
+  [PluginDependency("HeuristicLab.Attic", "1.0")]
   [PluginDependency("HeuristicLab.Analysis", "3.3")]
   [PluginDependency("HeuristicLab.Collections", "3.3")]
Index: branches/2936_GQAPIntegration/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Algorithms/3.3/Properties/AssemblyInfo.cs
===================================================================
--- branches/2936_GQAPIntegration/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Algorithms/3.3/Properties/AssemblyInfo.cs	(revision 16077)
+++ branches/2936_GQAPIntegration/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Algorithms/3.3/Properties/AssemblyInfo.cs	(revision 16712)
@@ -54,3 +54,3 @@
 // [assembly: AssemblyVersion("1.0.*")]
 [assembly: AssemblyVersion("3.3.0.0")]
-[assembly: AssemblyFileVersion("3.3.15.15890")]
+[assembly: AssemblyFileVersion("3.3.15.16077")]