Index: misc/tools/ConfigMerger/ConfigMerger.cs
===================================================================
--- misc/tools/ConfigMerger/ConfigMerger.cs	(revision 16667)
+++ misc/tools/ConfigMerger/ConfigMerger.cs	(revision 16715)
@@ -189,4 +189,12 @@
       sourceNode = source.SelectSingleNode("/configuration/oracle.manageddataaccess.client/version/dataSources");
       destinationNode = destination.SelectSingleNode("/configuration/oracle.manageddataaccess.client/version/dataSources");
+      Merge(sourceNode, destinationNode, destination, "/configuration");
+      
+      sourceNode = source.SelectSingleNode("/configuration/oracle.manageddataaccess.client/version/settings");
+      destinationNode = destination.SelectSingleNode("/configuration/oracle.manageddataaccess.client/version/settings");
+      Merge(sourceNode, destinationNode, destination, "/configuration");
+      
+      sourceNode = source.SelectSingleNode("/configuration/oracle.manageddataaccess.client/version/LDAPsettings");
+      destinationNode = destination.SelectSingleNode("/configuration/oracle.manageddataaccess.client/version/LDAPsettings");
       Merge(sourceNode, destinationNode, destination, "/configuration");
 
Index: misc/tools/ConfigMerger/ConfigMerger.csproj
===================================================================
--- misc/tools/ConfigMerger/ConfigMerger.csproj	(revision 16667)
+++ misc/tools/ConfigMerger/ConfigMerger.csproj	(revision 16715)
@@ -97,5 +97,5 @@
     <None Include="app.config" />
     <None Include="HeuristicLab.snk" />
-    <None Include="Properties\AssemblyInfo.frame" />
+    <None Include="Properties\AssemblyInfo.cs.frame" />
   </ItemGroup>
   <ItemGroup>
Index: misc/tools/ConfigMerger/ConfigMerger.sln
===================================================================
--- misc/tools/ConfigMerger/ConfigMerger.sln	(revision 16715)
+++ misc/tools/ConfigMerger/ConfigMerger.sln	(revision 16715)
@@ -0,0 +1,36 @@
+﻿
+Microsoft Visual Studio Solution File, Format Version 12.00
+# Visual Studio 15
+VisualStudioVersion = 15.0.28307.136
+MinimumVisualStudioVersion = 10.0.40219.1
+Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "ConfigMerger", "ConfigMerger.csproj", "{E94C5E71-3F29-408D-BCDF-23E096CA84CA}"
+EndProject
+Project("{2150E333-8FDC-42A3-9474-1A3956D46DE8}") = "Solution Items", "Solution Items", "{9A7139CB-8FE1-4319-A30C-2D95DFBD2CD2}"
+	ProjectSection(SolutionItems) = preProject
+		PreBuildEvent.cmd = PreBuildEvent.cmd
+	EndProjectSection
+EndProject
+Global
+	GlobalSection(SolutionConfigurationPlatforms) = preSolution
+		Debug|Any CPU = Debug|Any CPU
+		Debug|x86 = Debug|x86
+		Release|Any CPU = Release|Any CPU
+		Release|x86 = Release|x86
+	EndGlobalSection
+	GlobalSection(ProjectConfigurationPlatforms) = postSolution
+		{E94C5E71-3F29-408D-BCDF-23E096CA84CA}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
+		{E94C5E71-3F29-408D-BCDF-23E096CA84CA}.Debug|Any CPU.Build.0 = Debug|Any CPU
+		{E94C5E71-3F29-408D-BCDF-23E096CA84CA}.Debug|x86.ActiveCfg = Debug|x86
+		{E94C5E71-3F29-408D-BCDF-23E096CA84CA}.Debug|x86.Build.0 = Debug|x86
+		{E94C5E71-3F29-408D-BCDF-23E096CA84CA}.Release|Any CPU.ActiveCfg = Release|Any CPU
+		{E94C5E71-3F29-408D-BCDF-23E096CA84CA}.Release|Any CPU.Build.0 = Release|Any CPU
+		{E94C5E71-3F29-408D-BCDF-23E096CA84CA}.Release|x86.ActiveCfg = Release|x86
+		{E94C5E71-3F29-408D-BCDF-23E096CA84CA}.Release|x86.Build.0 = Release|x86
+	EndGlobalSection
+	GlobalSection(SolutionProperties) = preSolution
+		HideSolutionNode = FALSE
+	EndGlobalSection
+	GlobalSection(ExtensibilityGlobals) = postSolution
+		SolutionGuid = {7042041C-6BB0-45BA-8677-92F74406BB5B}
+	EndGlobalSection
+EndGlobal
Index: misc/tools/ConfigMerger/PreBuildEvent.cmd
===================================================================
--- misc/tools/ConfigMerger/PreBuildEvent.cmd	(revision 16715)
+++ misc/tools/ConfigMerger/PreBuildEvent.cmd	(revision 16715)
@@ -0,0 +1,11 @@
+IF EXIST "%ProjectDir%\Properties\AssemblyInfo.cs.frame" SubWCRev "%ProjectDir%\" "%ProjectDir%\Properties\AssemblyInfo.cs.frame" "%ProjectDir%\Properties\AssemblyInfo.cs"
+IF %ERRORLEVEL% NEQ 0 GOTO Error_Handling
+IF EXIST "%ProjectDir%\Plugin.cs.frame" SubWCRev "%ProjectDir%\" "%ProjectDir%\Plugin.cs.frame" "%ProjectDir%\Plugin.cs"
+IF %ERRORLEVEL% NEQ 0 GOTO Error_Handling
+GOTO Done
+
+:Error_Handling
+ECHO There was an error while running subwcrev. Please verify that the *.cs.frame files have been correctly converted to *.cs files, otherwise HeuristicLab won't build. 
+exit 0
+
+:Done
Index: misc/tools/ConfigMerger/Properties/AssemblyInfo.cs.frame
===================================================================
--- misc/tools/ConfigMerger/Properties/AssemblyInfo.cs.frame	(revision 16715)
+++ misc/tools/ConfigMerger/Properties/AssemblyInfo.cs.frame	(revision 16715)
@@ -0,0 +1,54 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Reflection;
+using System.Runtime.CompilerServices;
+using System.Runtime.InteropServices;
+
+// General Information about an assembly is controlled through the following 
+// set of attributes. Change these attribute values to modify the information
+// associated with an assembly.
+[assembly: AssemblyTitle("ConfigMerger")]
+[assembly: AssemblyDescription("Build tool to merge two config files.")]
+[assembly: AssemblyConfiguration("")]
+[assembly: AssemblyCompany("")]
+[assembly: AssemblyProduct("HeuristicLab")]
+[assembly: AssemblyCopyright("(c) 2002-2008 HEAL")]
+[assembly: AssemblyTrademark("")]
+[assembly: AssemblyCulture("")]
+
+// Setting ComVisible to false makes the types in this assembly not visible 
+// to COM components.  If you need to access a type in this assembly from 
+// COM, set the ComVisible attribute to true on that type.
+[assembly: ComVisible(false)]
+
+// The following GUID is for the ID of the typelib if this project is exposed to COM
+[assembly: Guid("66f1ddd8-fabe-4f73-bdcd-fa827b2aea93")]
+
+// Version information for an assembly consists of the following four values:
+//
+//      Major Version
+//      Minor Version 
+//      Build Number
+//      Revision
+//
+[assembly: AssemblyVersion("1.0.0.$WCREV$")]
+[assembly: AssemblyFileVersion("1.0.0.$WCREV$")]
Index: misc/tools/ConfigMerger/Properties/AssemblyInfo.frame
===================================================================
--- misc/tools/ConfigMerger/Properties/AssemblyInfo.frame	(revision 16667)
+++ 	(revision )
@@ -1,54 +1,0 @@
-#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-using System.Reflection;
-using System.Runtime.CompilerServices;
-using System.Runtime.InteropServices;
-
-// General Information about an assembly is controlled through the following 
-// set of attributes. Change these attribute values to modify the information
-// associated with an assembly.
-[assembly: AssemblyTitle("ConfigMerger")]
-[assembly: AssemblyDescription("Build tool to merge two config files.")]
-[assembly: AssemblyConfiguration("")]
-[assembly: AssemblyCompany("")]
-[assembly: AssemblyProduct("HeuristicLab")]
-[assembly: AssemblyCopyright("(c) 2002-2008 HEAL")]
-[assembly: AssemblyTrademark("")]
-[assembly: AssemblyCulture("")]
-
-// Setting ComVisible to false makes the types in this assembly not visible 
-// to COM components.  If you need to access a type in this assembly from 
-// COM, set the ComVisible attribute to true on that type.
-[assembly: ComVisible(false)]
-
-// The following GUID is for the ID of the typelib if this project is exposed to COM
-[assembly: Guid("66f1ddd8-fabe-4f73-bdcd-fa827b2aea93")]
-
-// Version information for an assembly consists of the following four values:
-//
-//      Major Version
-//      Minor Version 
-//      Build Number
-//      Revision
-//
-[assembly: AssemblyVersion("1.0.0.$WCREV$")]
-[assembly: AssemblyFileVersion("1.0.0.$WCREV$")]